#include <scheme.h>

#include "actkbd.h"

/* is the device currently grabbed? */
static int grabbed_p(void) {
	/* this value comes from C, so an extra assert won't hurt */
	assert((grabbed == 0) || (grabbed == 1));
	return grabbed;
}

void extension_init(void) {
	FILE *stream;

	assert(config != NULL);

	Sscheme_init(0);
	Sregister_boot_file(CHEZDIR "/petite.boot");
	Sregister_boot_file(CHEZDIR "/scheme.boot");
	Sbuild_heap(0, 0);

	Sforeign_symbol("bind",        (ptr) &set_cb);
	Sforeign_symbol("grab",      (ptr) &set_grab);
	Sforeign_symbol("grabbed?", (ptr) &grabbed_p);
	Sforeign_symbol("led",        (ptr) &set_led);

	/* test whether we can read the config */
	stream = fopen(config, "r");
	if (!stream) {
		fprintf(stderr, "ERROR : %s not found or reading is not allowed.\n",
		        config);
		exit(CONFERR);
	}
	fclose(stream);
	Sscheme_program(config, 0, NULL);
}

/* a shortcut to reload stuff */
void extension_reload(void) {
	Sscheme_program(config, 0, NULL);
}

void extension_cleanup_callback(CB fun) {
	/* so the gc will be able to collect it */
	Sunlock_object(fun);
}
